﻿@page "/referees/create"
@page "/referees/edit/{Id:int}"

@using Models.RefereeData
@using Business.Repository.IRepository
@inject NavigationManager NavigationManager
@inject IJSRuntime JsRuntime
@inject IRefereeRepository RefereeRepository

<div class="row mt-2 mb-5">
    <h3 class="card-title text-info mb-3 ml-3">@Title Referee</h3>
    <div class="col-md-12">
        <div class="card">
            <div class="card-body">
                <EditForm Model="@RefereeModel" OnValidSubmit="HandleCreateUpdate">
                    <DataAnnotationsValidator />
                    @*<ValidationSummary />*@
                    <div class="form-group">
                        <label>Name</label>
                        <InputText @bind-Value="RefereeModel.Name" class="form-control"></InputText>
                        <ValidationMessage For="() => RefereeModel.Name" />
                    </div>
                    <div class="form-group">
                        <label>Surname</label>
                        <InputText @bind-Value="RefereeModel.Surname" class="form-control"></InputText>
                        <ValidationMessage For="() => RefereeModel.Surname" />
                    </div>
                    <div class="form-group">
                        <button class="btn btn-primary">@Title Referee </button>
                        <NavLink href="referees" class="btn btn-secondary">Back to Index</NavLink>
                    </div>
                </EditForm>
            </div>
        </div>
    </div>
</div>



@code {

    [Parameter]
    public int? Id { get; set; }
    private RefereeDTO RefereeModel { get; set; } = new RefereeDTO();
    private string Title { get; set; } = "Create";
    protected override async Task OnInitializedAsync()
    {
        if (Id != null)
        {
            //update
            Title = "Update";
            RefereeModel = await RefereeRepository.Get(Id.Value);
        }
        else
        {
            //create
            RefereeModel = new RefereeDTO();
        }
    }
    private async Task HandleCreateUpdate()
    {
        try
        {
            // add check if referee is unique
            // --
            // --
            if (RefereeModel.Id != 0 && Title == "Update")
            {
                //update
                var updateReferee = await RefereeRepository.Update(RefereeModel, RefereeModel.Id);
                await JsRuntime.ToastrSuccess("Referee updated successfully");
                await Task.Delay(300);
                NavigationManager.NavigateTo("/referees", true);

            }
            else
            {
                //create
                var createdResult = await RefereeRepository.Create(RefereeModel);

                await JsRuntime.ToastrSuccess("Referee created successfully");
                await Task.Delay(300);
                NavigationManager.NavigateTo("/referees", true);
            }
        }
        catch(Exception ex)
        {
            throw ex;
        }
    }
}
